/*  Copyright © 2016 Zoltán Nagy. All rights reserved.
 *  Created by Zoltán Nagy on 16/05/16.
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program. If not, see <http://www.gnu.org/licenses/>.
 */

/*   std headers   */
#include <string>

/*   C headers   */
#include <getopt.h>

/*   project headers   */
#include "bits/duct-model.h"


/*     This is the main function. Now I can do this....   */
using namespace duct;
using namespace std;

extern void blurb();


static bool check(const string& name, int idx, int argc, char **argv)
{
  for(; idx < argc; idx++)
    if(name == argv[idx]) return true;
  
  return false;
}

int main_pdf(int argc, char **argv)
{
  /*   print fancy message   */
  blurb();
  
  /*   generating pdfs    */
  for(const qcd::predefined **p = qcd::default_inputs; *p != nullptr; p++)
    if(::optind == argc || check((*p)->name, ::optind, argc, argv)) {
      cout<<"\033[1;31mCalculating the DGALP evolution of \033[0m\"\033[1;34m"<<(*p)->name<<"\033[0m\"\033[1;31m PDF set..."<<flush;
      model mdl{**p};
      cout<<"\t      \033[1;32m...done\033[0m\n";
    }
  
  
  return 0;
}

